/*
 *
 *  DpkgAnt
 *  Copyright (c) 2001 Max Kellermann (max.kellermann@epost.de)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: BuildDebianPackage.java,v 1.1.1.1 2001/07/10 18:18:53 max Exp $
 *
 */

package make.ant;

import java.io.File;
import java.io.IOException;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class BuildDebianPackage extends Task {
    /*properties********************/
    protected File file, baseDir;

    /*Task Methods***********************/
    public void execute() throws BuildException {
	try {
	    Runtime runtime = Runtime.getRuntime();

	    // build the command line
	    String[] cmd = {
		"/usr/bin/dpkg", "--build",
		baseDir.getAbsolutePath(),
		file.getAbsolutePath(),
	    };

	    System.out.print("Running dpkg: ");
	    for (int z=0; z<cmd.length; z++)
		System.out.print(" "+cmd[z]);
	    System.out.println();
	    
	    // create the dpkg process and run it
	    Process process = runtime.exec(cmd);
	    int returnValue = process.waitFor();

	    // check the returned value
	    if (returnValue!=0) {
		throw new BuildException("Debian dpkg returned code "+returnValue);
	    }
	    
	} catch (InterruptedException e) {
	    throw new BuildException("Interrupted while waiting for Debian dpkg", e);
	} catch (IOException e) {
	    throw new BuildException("Debian dpkg returned error", e);
	}
    }
    public void setDebfile(File _file) {
	file = _file;
    }
    public void setBasedir(File _bd) {
	baseDir = _bd;
    }
}
